//NPM Imports
import * as React from 'react';

//Component Imports
// import ListItem from './listItem/listItem';


//Object Model Imports


//Interface(s) for this class
export interface iListProps {
    children : Array<JSX.Element>;
    className : string;
}
export interface iListState {}

export default class List extends React.Component<iListProps, iListState>{

    constructor(props: iListProps){
        super(props);
        this.state = {}
    }

    render(){
        return (
            <div className={`ListContent ${this.props.className}`}>
                {this.props.children}
            </div>
        );
    }
}